package com.test.referencedata.impl;

import java.util.HashSet;
import java.util.Set;

import org.infinispan.container.entries.InternalCacheEntry;
import org.infinispan.container.entries.InternalEntryFactory;
import org.infinispan.loaders.AbstractCacheLoader;
import org.infinispan.loaders.CacheLoaderConfig;
import org.infinispan.loaders.CacheLoaderException;

import com.test.referencedata.SimpleDomain;

public class SimpleDomainLoader extends AbstractCacheLoader {

	private static final int NUM = 1000000;
	
	@Override
	public Class<? extends CacheLoaderConfig> getConfigurationClass() {		
		return SimpleDomainLoaderConfig.class;
	}

	@Override
	public InternalCacheEntry load(Object key) throws CacheLoaderException {
		return InternalEntryFactory.create(key, new SimpleDomain((Integer)key, key + ""));
	}

	@Override
	public Set<InternalCacheEntry> load(int count) throws CacheLoaderException {
		Set<InternalCacheEntry> entries = new HashSet<InternalCacheEntry>();
		for (int i=0;i<count;i++) {
			entries.add(load((Object)i));
		}
		return entries;
	}

	@Override
	public Set<InternalCacheEntry> loadAll() throws CacheLoaderException {
		Set<InternalCacheEntry> entries = new HashSet<InternalCacheEntry>();
		for (int i=0;i<NUM;i++) {
			entries.add(load((Object)i));
		}
		return entries;
	}

	@Override
	public Set<Object> loadAllKeys(Set<Object> arg0)
			throws CacheLoaderException {
		Set<Object> entries = new HashSet<Object>();
		for (int i=0;i<NUM;i++) {
			entries.add(i);
		}
		return entries;
	}

	@Override
	public void start() throws CacheLoaderException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void stop() throws CacheLoaderException {
		// TODO Auto-generated method stub
		
	}

}
